from pasteob.base import *
from pasteob.errors import *
from pasteob.dispatch import *
from pasteob.reqaddon import *
from pasteob.overrides import *

__all__ = [
    'Request', 'Response', 'OverrideResponse',
    'wapp', 'wapp_mw',
    'ErrorResponse', 'RedirectResponse',
    'ReqAddon',
    'PathMatch', 'PathMap', 'HostMap', 'Autodispatch',
    'fix_HEAD', 'override_https', 'override_errors', 'chrome_frame_mw', 'Cascade', 'SiteRoot',
    'gzip_mw',
]

wapp.error_404 = ErrorResponse(404)

@wapp_mw
def gzip_mw(req, app):
    #@@ technically we should add Vary: Content-Encoding header
    # for all compressible content
    if 'gzip' not in req.accept_encoding:
        return app
    resp = app << req
    if not resp.content_encoding and 'zip' not in resp.ctype:
        for typestr in ['text', 'javascript', 'xml']:
            if typestr in resp.ctype:
                resp.encode_content()
    return resp


